#include "uogetopt.h"
#include "_stralloc.h"
#include "_error.h"
#include "_str.h"
#include "_ip4.h"
#include "_alloc.h"
#include "_buffer.h"
#include "_scan.h"
#include "fmt.h"
#include "getln.h"
#include "byte.h"
#include "open.h"
#include "strhash.h"
#include "bailout.h"
#include "interface.h"
#include "accorec.h"
#include "die_write.h"

static strhash_t ihash;

void
accorecord(const char *ipfrom,const char *ipto,
			unsigned long packets,unsigned long bytes)
{
	accorec_t *f;
	accorec_t *t;
	f=accorec_lookup(&ihash,ipfrom,4); /* XXX ipv4 */
	if (!f)
		f=accorec_new(&ihash,ipfrom,4,0);
	if (!f)
		oom();
	if (!accorec_add(f,0,0,packets,bytes)) 
		oom();
	t=accorec_lookup(&ihash,ipto,4); /* XXX ipv4 */
	if (!t)
		t=accorec_new(&ihash,ipto,4,0);
	if (!t)
		oom();
	if (!accorec_add(t,0,0,packets,bytes)) 
		oom();
}


static void dump(void)
{
	strhash_walkstart(&ihash);
	while (1) {
		int x;
		char *k;
		unsigned int kl;
		accorec_t *i;
		x=strhash_walk(&ihash,&k,&kl, (char **)&i,0);
		if (!x)
			break;
		accorec_print(k,kl,i);
	}
}

static uogetopt_t opts[]={
{0,"",UOGO_MINARGS | UOGO_HIDDEN,0, 1 , 0,0},
{0,"",UOGO_MAXARGS | UOGO_HIDDEN,0, 1 , 0,0},
{'\0',0,UOGO_FLAG,0,0,0,0}
};
static const char *usagestring=
"usage: cacco-ip [options] <in >out";
int 
main(int argc, char **argv)
{
	bailout_progname(argv[0]);
	uogetopt(flag_bailout_log_name,PACKAGE,VERSION,
		&argc,argv,uogetopt_out,
		usagestring, opts,0);
	if (-1==strhash_create(&ihash,256,32,strhash_hash)) oom();
	accorec_print_name1=accorec_print_ipv4;
	readloop(0);
	dump();
	if (-1==buffer_flush(buffer_1)) die_write();
	exit(0);
}
